diff --git a/ext/nokogiri/xml_document.c b/ext/nokogiri/xml_document.c
index ca48ffac9..c0cadc329 100644
--- a/ext/nokogiri/xml_document.c
+++ b/ext/nokogiri/xml_document.c
@@ -1,22 +1,5 @@
 #include <xml_document.h>
 
-static int dealloc_node_i(xmlNodePtr key, xmlNodePtr node, xmlDocPtr doc)
-{
-  switch(node->type) {
-  case XML_ATTRIBUTE_NODE:
-    xmlFreePropList((xmlAttrPtr)node);
-    break;
-  case XML_NAMESPACE_DECL:
-    xmlFree(node);
-    break;
-  default:
-    if(node->parent == NULL) {
-      xmlAddChild((xmlNodePtr)doc, node);
-    }
-  }
-  return ST_CONTINUE;
-}
-
 static void remove_private(xmlNodePtr node)
 {
   xmlNodePtr child;
@@ -35,6 +18,18 @@ static void remove_private(xmlNodePtr node)
   node->_private = NULL;
 }
 
+static int dealloc_node_i(xmlNodePtr key, xmlNodePtr node, void *unused)
+{
+  if (node->parent == NULL)
+  {
+    if (xmlDeregisterNodeDefaultValue)
+      remove_private(node);
+    xmlFreeNode(node);
+  }
+  return ST_CONTINUE;
+}
+
+
 static void dealloc(xmlDocPtr doc)
 {
   st_table *node_hash;
@@ -43,7 +38,7 @@ static void dealloc(xmlDocPtr doc)
 
   node_hash  = DOC_UNLINKED_NODE_HASH(doc);
 
-  st_foreach(node_hash, dealloc_node_i, (st_data_t)doc);
+  st_foreach(node_hash, dealloc_node_i, (st_data_t)0);
   st_free_table(node_hash);
 
   free(doc->_private);
